require 'active_record'
class GraphMatrixDb < ActiveRecord::Base
  validates edge_matrix, presence: true

  def get_out_edge_matrix(vertex)
    return if (vertex < 0 || vertex >= @edge_matrix.length)
    vertices = []
    (0..(@edge_matrix.length - 1)).each do |index|
      vertices << index if @edge_matrix[vertex][index] == 1
    end
    vertices
  end

  def get_in_edge_matrix(vertex)
    return if (vertex < 0 || vertex >= @edge_matrix)
    vertices = []
    (0..(@edge_matrix.length - 1)).each do |index|
      vertices << index if @edge_matrix[index][vertex] == 1
    end
    vertices
  end
  
  def vertices
    vertices = []
    (0..(@edge_matrix.length - 1)).each do |index|
      vertices << index
    end
    vertices
  end
  
  def edges
    result = []
    (0..(@edge_matrix.length - 1)).each do |index|
      (0..(@edge_matrix.length - 1)).each do |s_index|
        result << [index, s_index] if @edge_matrix[index][s_index] == 1
      end
    end
    result
  end
  
end